import { DatabaseSchema } from "./mysql-database-definition";
import * as Knex from "knex";
/**
 *
 */
export default class TsBuilder {
    private schema;
    mysqlTypes: {
        int: string;
        decimal: string;
        double: string;
        float: string;
        set: string;
        bigint: string;
        longblob: string;
        tinyint: string;
        date: string;
        smallint: string;
        datetime: string;
        timestamp: string;
        text: string;
        longtext: string;
        mediumtext: string;
        varchar: string;
        char: string;
    };
    settings: {
        singularizeClassNames: boolean;
        defaultClassName: string;
        optionalParameters: boolean;
        camelCaseFnNames: boolean;
    };
    constructor(schema?: DatabaseSchema);
    static init(knex: Knex): Promise<TsBuilder>;
    init(knex: Knex, dbName?: string): Promise<TsBuilder>;
    private toFilename(name);
    private static normFolder(folder);
    renderTableFile(folder: string): void;
    renderViewFile(folder: string): void;
    renderColumnsFile(folder: string): void;
    renderClassFiles(folder: string, searchString?: string): void;
    renderViewClassFiles(folder: string, searchString?: string): void;
    renderInserter(folder: string, interfaceFolder: string): void;
    renderStoredProcedure(folder: string): void;
    private renderClasses(tables, folder);
    private static listTables(tables, searchFor?);
    private listTables(searchFor?);
    private listViews(searchFor?);
    private getClassName(tableName);
}
